﻿using System.Windows.Forms;
using System;
using System.Drawing;
using System.Diagnostics;

namespace LogAnalysiser
{
    /// <summary>
    /// 备用类，留作窗体换肤用。
    /// </summary>
    [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand,Name="FullTrust")]
    public class FormMessageListener:NativeWindow
    {
        private Form _parentForm;

        public FormMessageListener(Form parent)
        {
            parent.HandleCreated += OnHandleCreated;
            parent.HandleDestroyed += OnHandleDestroyed;
            _parentForm = parent;
        }

        private void OnHandleCreated(object sender, EventArgs e)
        {
            AssignHandle(((Form)sender).Handle);
        }

        private void OnHandleDestroyed(object sender, EventArgs e)
        {
            ReleaseHandle();
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case 0x00A0:
                    Point screebPoint = new Point(m.LParam.ToInt32());
                    Debug.WriteLine(screebPoint);
                    break;
                default: break;
            }

            base.WndProc(ref m);
        }
    }
}
