﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Windows.Forms;
using System.IO;

namespace LogAnalysiser
{
    /// <summary>
    /// 操作XML的类
    /// </summary>
    public class XmlOperation
    {

        private string fileNameThis = Application.StartupPath + "/LogAnalysiser.exe.config";

        /// <summary>
        /// 保存XML节点值
        /// </summary>
        /// <param name="value">待保存的值</param>
        public void Save(string value)
        {
            XmlDocument doc;
            string fileName;
            XmlNodeList nodes = GetNode(out doc, out fileName);
            for (int i = 0; i < nodes.Count; i++)
            {
                XmlAttribute attribute = nodes[i].Attributes["key"];
                if (attribute.Value == "MySet")
                {
                    attribute = nodes[i].Attributes["value"];
                    attribute.Value = value;
                    break;
                }
            }
            doc.Save(fileName);
        }

        /// <summary>
        /// 读取XMl中MySet节点的值
        /// </summary>
        /// <returns>返回string类型</returns>
        public string Read()
        {
            XmlDocument doc;
            string fileName;
            XmlNodeList nodes = GetNode(out doc, out fileName);
            for (int i = 0; i < nodes.Count; i++)
            {
                XmlAttribute attribute = nodes[i].Attributes["key"];
                if (attribute.Value == "MySet")
                {
                    return nodes[i].Attributes["value"].Value;
                }
            }
            return string.Empty;
        }

        /// <summary>
        /// 得到add节点下的列表
        /// </summary>
        /// <param name="doc"></param>
        /// <param name="fileName"></param>
        /// <returns></returns>
        private XmlNodeList GetNode(out XmlDocument doc, out string fileName)
        {
            XmlDocument docThis = new XmlDocument();
            doc = docThis;
            
            fileName = fileNameThis;

            doc.Load(fileName);
            XmlNodeList nodes = doc.GetElementsByTagName("add");
            return nodes;
        }

        /// <summary>
        /// 创建一个特定的XML文档
        /// </summary>
        public void CreateXMLDocument()
        {
            XmlDocument xmlDoc = new XmlDocument();
            XmlDeclaration xmlDec = xmlDoc.CreateXmlDeclaration("1.0", "utf-8", null);
            xmlDoc.AppendChild(xmlDec);

            XmlElement xmlEleFirst = xmlDoc.CreateElement("", "configuration", "");
            xmlDoc.AppendChild(xmlEleFirst);

            XmlElement xmlEleSecond = xmlDoc.CreateElement("", "appSettings","");
            xmlEleFirst.AppendChild(xmlEleSecond);

            XmlElement xmlEleThird = xmlDoc.CreateElement("", "add", "");
            xmlEleThird.SetAttribute("key", "MySet");
            xmlEleThird.SetAttribute("value", "behaviors");
            xmlEleSecond.AppendChild(xmlEleThird);

            xmlDoc.Save(fileNameThis);
        }
    }
}
