﻿using System.Windows.Forms;
using System;
using System.Xml;
using System.Threading;
using LogAnalysiser;

namespace LogAnalysiser
{
    /// <summary>
    /// 配置窗体，主要用于配置待过滤关键字或者子句。
    /// </summary>
    public partial class ConfigFrm : Form
    {
        /// <summary>
        /// 构造函数
        /// </summary>
        public ConfigFrm()
        {
            InitializeComponent();
            if (operation == null)
            {
                operation = new XmlOperation();
            }
        }

        /// <summary>
        /// Xml操作类
        /// </summary>
        public XmlOperation operation;

        /// <summary>
        /// 窗体加载
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void ConfigFrm_Load(object sender, System.EventArgs e)
        {
            //System.Configuration.AppSettingsReader reader = new System.Configuration.AppSettingsReader();
            //string value = reader.GetValue("MySet", typeof(String)).ToString();
            txtContent.Text = operation.Read();
        }

        /// <summary>
        /// 配置过滤关键字
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnOK_Click(object sender, EventArgs e)
        {
            if (!String.IsNullOrEmpty(txtContent.Text))
            {
                string value = txtContent.Text;
                operation.Save(value);
                MessageBox.Show("配置成功！");
            }
            else
            {
                MessageBox.Show("请输入过滤关键字或者句子！");
                return;
            }
            txtContent.Text = operation.Read();
        }
    }
}
