﻿using System;
using System.Windows.Forms;

namespace LogAnalysiser
{
    /// <summary>
    /// 全局委托，用于着色
    /// </summary>
    /// <param name="text">待着色文本</param>
    public delegate void ColorDaemonDelegate(string text);

    /// <summary>
    /// 着色窗体，用于实时文本着色
    /// </summary>
    public partial class DaemonFrm : Form
    {
        /// <summary>
        /// 构造函数
        /// </summary>
        public DaemonFrm()
        {
            InitializeComponent();
        }

        /// <summary>
        /// 委托事件
        /// </summary>
        public event ColorDaemonDelegate OnColorDaemonEventHandler;

        /// <summary>
        /// 着色按钮点击事件触发
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnColor_Click(object sender, EventArgs e)
        {
            string text = txtWordDaemon.Text;
            OnColorDaemonEventHandler(text);  //抛出事件
        }
    }
}
