﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace LogAnalysiser
{
    public delegate void HookSlashCloseDelegate();

    public partial class SlashFrm : Form
    {
        public SlashFrm()
        {
            InitializeComponent();
        }

        public event HookSlashCloseDelegate OnHookSlashCloseEvent; //抛出窗体关闭事件，用于通知主窗体更新

        private void SlashFrm_Load(object sender, EventArgs e)
        {
            tTick.Enabled = true;
            this.ShowInTaskbar = false;
        }

        private void DoPrograss()
        {
            //1.检查Config文件是否存在 不存在则创建 LogAnalysiser.exe.config
            //2.检查upgrade.exe文件是否存在  不存在则提示更新的配置文件缺失  upgrade.exe.config
            //3.检查更新地址和更新文件是否存在 如果存在upgrade.exe.config  则检查是否有version 和 fileName 节点
            //4.检查Version的值 
            if (prograssStatus.Value == 1) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "开始检测LogAnalysiser.exe.config配置文件..."; }));

            //prograssStatus.Invoke(new Action(delegate { prograssStatus.Value = 1; }));

            string appConfigPath = Application.StartupPath + "\\LogAnalysiser.exe.config";
            if (File.Exists(appConfigPath))
            {
                if (prograssStatus.Value == 10) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "LogAnalysiser.exe.config文件存在..."; }));
            }
            else
            {
                if (prograssStatus.Value == 10) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "LogAnalysiser.exe.config文件丢失,开始创建..."; }));
                XmlOperation xmlOperation = new XmlOperation();
                xmlOperation.CreateXMLDocument();
                if (prograssStatus.Value == 20)  lblStatus.Invoke(new Action(delegate { lblStatus.Text = "LogAnalysiser.exe.config文件创建完毕..."; }));
            }

            string upgradeConfigPath = Application.StartupPath + "\\upgrade.exe.config";
            if (File.Exists(upgradeConfigPath))
            {
                if (prograssStatus.Value == 30) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "upgrade.exe.config文件存在..."; }));
            }
            else
            {
                if (prograssStatus.Value == 30) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "upgrade.exe.config文件不存在..."; }));
            }

            string upgradeExePath = Application.StartupPath + "\\upgrade.exe";
            if (File.Exists(upgradeExePath))
            {
                if (prograssStatus.Value == 60) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "upgrade.exe文件存在..."; }));
            }
            else
            {
                if (prograssStatus.Value == 60) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "upgrade.exe文件不存在..."; }));
            }

            string versionNum = Assembly.Load(File.ReadAllBytes("LogAnalysiser.exe")).GetName().Version.ToString();
            if (prograssStatus.Value == 80)
            {
                if (!String.IsNullOrEmpty(versionNum)) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "当前Version版本号:" + versionNum; }));
                else lblStatus.Invoke(new Action(delegate { lblStatus.Text = "获取版本号失败..."; }));
            }

            if (prograssStatus.Value == 90) lblStatus.Invoke(new Action(delegate { lblStatus.Text = "主程序启动中..."; }));

        }

        private void BeginDo()
        {
            Action action = new Action(DoPrograss);
            action.BeginInvoke(new AsyncCallback(EndDo), action);
        }

        private void EndDo(IAsyncResult iar)
        {
            Action action = (Action)iar.AsyncState;
            action.EndInvoke(iar);
        }

        private void tTick_Tick(object sender, EventArgs e)
        {
            prograssStatus.Value++;
            BeginDo();
            if (prograssStatus.Value == 100)
            {
                tTick.Enabled = false;

                OnHookSlashCloseEvent();  //加载完毕，抛出事件通知主窗体
                this.Close(); //关闭当前窗体
                this.Dispose(); //销毁
            }
        }
    }
}
